<template>
	<v-row justify="center">
		<v-card min-width="900">
			<v-card-title>
				Instituciones
				<v-spacer></v-spacer>
				<v-text-field
					v-model="filterInstitute"
					prepend-icon="fas fa-search"
					label="Ingrese una institución"
				/>
			</v-card-title>
			<v-data-table
				:headers="headers"
				:items="items"
				:search="filterInstitute"
				:footer-props="{itemsPerPageText: 'Instituciones por página'}"
				no-results-text="Institución no encontrada"
				no-data-text="No hay instituciones agregadas"
			>
				<template v-slot:item.action="{ item }">
					<v-tooltip bottom>
						<template v-slot:activator="{ on }">
							<v-btn text icon color="success" v-on="on" @click="openModalScoreInstitute(item)">
								<v-icon>fas fa-edit</v-icon>
							</v-btn>
						</template>
						<span>Actualizar puntaje</span>
					</v-tooltip>
					<v-tooltip bottom>
						<template v-slot:activator="{ on }">
							<v-btn text icon color="purple" v-on="on" @click="openVisibleChangeNameInstitute(item)">
								<v-icon>fas fa-pencil-alt</v-icon>
							</v-btn>
						</template>
						<span>Cambiar nombre</span>
					</v-tooltip>
					<v-tooltip bottom>
						<template v-slot:activator="{ on }">
							<v-btn text icon color="orange" v-on="on" @click="openFormNewCareer(item)">
								<v-icon>fas fa-plus</v-icon>
							</v-btn>
						</template>
						<span>Agregar carrera</span>
					</v-tooltip>
					<v-tooltip bottom>
						<template v-slot:activator="{ on }">
							<v-btn text icon color="blue" v-on="on" @click="openModalCareers(item)">
								<v-icon>fas fa-graduation-cap</v-icon>
							</v-btn>
						</template>
						<span>Ver carreras</span>
					</v-tooltip>
					<v-tooltip bottom>
						<template v-slot:activator="{ on }">
							<v-btn text icon color="red" v-on="on" @click="deleteIns(item)">
								<v-icon>fas fa-trash-alt</v-icon>
							</v-btn>
						</template>
						<span>Eliminar institución</span>
					</v-tooltip>
				</template>
			</v-data-table>
		</v-card>
		<ModalUpdateScoreInstitute
			:visibleForm="visibleScoreInstitute"
			:institute="instituteSelected"
			:valor="scoreInstitute"
		/>
		<FormNewCareer :visibleForm="visible" :institute="instituteSelected" />
		<ModalCareers :visibleForm="visibleCareers" :institute="instituteSelected" :careers="careers" />
		<ModalChangeNameInstitute :visible="visibleChangeNameInstitute" :nameInstitute="nameInstitute"/>
		<ModalConfirmDeleteInstitute :visible="visibleConfirmDelete" :nameInstitute="nameInstitute" />
	</v-row>
</template>

<script>
import gql from "graphql-tag";
import EventBus from "../../bus";
import FormNewCareer from "@/components/admin/FormNewCareer";
import ModalCareers from "@/components/admin/ModalCareers";
import ModalUpdateScoreInstitute from "@/components/admin/ModalUpdateScoreInstitute";
import ModalChangeNameInstitute from "@/components/admin/ModalChangeNameInstitute";
import ModalConfirmDeleteInstitute from "@/components/admin/ModalConfirmDeleteInstitute";
import { mapActions } from 'vuex';

export default {
	name: "UsersTable",
	components: { FormNewCareer, ModalCareers, ModalUpdateScoreInstitute, ModalChangeNameInstitute, ModalConfirmDeleteInstitute },
	data: () => ({
		filterInstitute: "",
		routeName: "",
		headers: [
			{ text: "Id", value: "id", filterable: false },
			{ text: "Institución", value: "institute" },
			{
				text: "Puntaje",
				value: "value",
				align: "center",
				filterable: false
			},
			{
				text: "Acciones",
				value: "action",
				align: "center",
				filterable: false
			}
		],
		items: [],
		visible: false,
		instituteSelected: "",
		careers: [],
		visibleCareers: false,
		visibleScoreInstitute: false,
		visibleChangeNameInstitute: false,
		visibleConfirmDelete: false,
		scoreInstitute: 0,
		nameInstitute: ""
	}),
	methods: {
		...mapActions(['deleteInstitute']),
		// obtiene las instituciones
		async getInstitutes() {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query {
							allInstitutes {
								institute
								value
							}
						}
					`
				});
				let cont = 1;
				this.items = data.allInstitutes;
				// Le agrega la propiedad id con el valor del contador
				for (let i of this.items) {
					Object.defineProperty(i, "id", { value: cont++ });
				}
			} catch (error) {}
		},
		// Obtiene las carreras
		async getCareer(item) {
			try {
				const { data } = await this.$apollo.query({
					query: gql`
						query($institute: String!) {
							allCareers(institute: $institute) {
								key
								value
							}
						}
					`,
					variables: {
						institute: item
					}
				});
				this.careers = data.allCareers;
			} catch (error) {}
		},
		// abre el modal para ver las carreras
		openModalCareers(item) {
			this.getCareer(item.institute);
			this.instituteSelected = item.institute;
			this.visibleCareers = true;
		},
		// Abre el formulario de nueva carrera
		openFormNewCareer(item) {
			this.instituteSelected = item.institute;
			this.visible = true;
		},
		// Abre el modal del puntaje de institución
		openModalScoreInstitute(item) {
			this.instituteSelected = item.institute;
			this.scoreInstitute = item.value;
			this.visibleScoreInstitute = true;
		},
		// elimina un instituto
		deleteIns(item){
			this.visibleConfirmDelete = true;
			this.nameInstitute = item.institute;
		},
		// abre el formulario para cambiar el nombre
		openVisibleChangeNameInstitute(item){
			this.visibleChangeNameInstitute = true;
			this.nameInstitute = item.institute;
		}
	},
	created() {
		this.getInstitutes();
	},
	mounted() {
		EventBus.$on("sendInstitute", institute => {
			this.getInstitutes();
		});

		EventBus.$on("closeFormNewCareer", () => {
			this.visible = false;
		});

		EventBus.$on("closeModalCareers", () => {
			this.visibleCareers = false;
		});

		EventBus.$on("closeModalUpdateScoreInstitute", () => {
			this.visibleScoreInstitute = false;
			this.getInstitutes();
		});

		EventBus.$on("closeChangeNameInstitute",() => {
			this.visibleChangeNameInstitute = false;
		});

		EventBus.$on("succChangeNameInstitute", () => {
			this.getInstitutes();
			this.visibleChangeNameInstitute = false;
		});

		EventBus.$on("closeConfirmDeleteInstitute",() => {
			this.visibleConfirmDelete = false;
		});

		EventBus.$on("confirmDeleteInstitute",(institute) => {
			this.deleteInstitute(institute);
			this.items = this.items.filter(i => i.institute !== institute);
			this.visibleConfirmDelete = false;
		});

		EventBus.$on("closeUpdateScoreCareer",(institute) => {
			this.getCareer(institute);
		});

		EventBus.$on("succChangeNameCareer",(institute) => {
			this.getCareer(institute);
		});

		EventBus.$on("succDeleteCareer", (institute) => {
			this.getCareer(institute);
		});
	}
};
</script>
